<?php

/*********************************************************************

 Twitterフォロワー限定公開プラグイン (2013/06/29)

 Copyright(C) 2009-2013 freo.jp

*********************************************************************/

//外部ファイル読み込み
set_include_path(get_include_path() . PATH_SEPARATOR . getcwd() . '/' . FREO_MAIN_DIR . 'PEAR/');
require_once 'HTTP/OAuth/Consumer.php';

/* メイン処理 */
function freo_page_twitter_followers()
{
	global $freo;

	//OAuth
	$consumer = new HTTP_OAuth_Consumer(FREO_PLUGIN_TWITTER_FOLLOWERS_CONSUMER_KEY, FREO_PLUGIN_TWITTER_FOLLOWERS_CONSUMER_SECRET);

	//認証
	if (isset($_GET['denied'])) {
		freo_error('認証できませんでした。');
	} elseif (isset($_GET['oauth_verifier'])) {
		$token        = null;
		$token_secret = null;

		try {
			$consumer->setToken($_SESSION['plugin']['twitter_followers']['request_token']);
			$consumer->setTokenSecret($_SESSION['plugin']['twitter_followers']['request_token_secret']);
			$consumer->getAccessToken('http://api.twitter.com/oauth/access_token', $_GET['oauth_verifier']);

			$token        = $consumer->getToken();
			$token_secret = $consumer->getTokenSecret();
		} catch (Exception $e) {
			freo_error($e->getMessage());
		}

		if ($token and $token_secret) {
			//フォロワーのIDを取得
			$followers = array();
			$cursor    = -1;

			while (1) {
				$response = $consumer->sendRequest('http://api.twitter.com/1.1/followers/ids.json', array('screen_name' => $freo->config['plugin']['twitter_followers']['screen_name'], 'cursor' => $cursor), 'GET');

				$json = json_decode($response->getBody());

				if (isset($json->errors)) {
					freo_error($json->errors[0]->message);
				}

				foreach ($json->ids as $id) {
					$followers[$id] = true;
				}

				$cursor = $json->next_cursor_str;

				if ($cursor == 0) {
					break;
				}
			}

			//ユーザー情報を取得
			$response = $consumer->sendRequest('http://api.twitter.com/1.1/account/verify_credentials.json', array(), 'GET');

			$json = json_decode($response->getBody());

			if (isset($json->errors)) {
				freo_error($json->errors[0]->message);
			}

			$id = $json->id;

			//結果を保持
			if (isset($followers[$id])) {
				$freo->user['groups'][] = $freo->config['plugin']['twitter_followers']['group'];

				$_SESSION['freo']['user'] = $freo->user;

				$error = false;
			} else {
				$error = true;
			}

			//元の記事へ移動
			if (!empty($_SESSION['plugin']['twitter_followers']['entry_id'])) {
				freo_redirect('view/' . $_SESSION['plugin']['twitter_followers']['entry_id'] . ($error ? '?error=1' : ''));
			} elseif (!empty($_SESSION['plugin']['twitter_followers']['page_id'])) {
				freo_redirect('page/' . $_SESSION['plugin']['twitter_followers']['page_id'] . ($error ? '?error=1' : ''));
			} elseif (!empty($_SESSION['plugin']['twitter_followers']['media_path'])) {
				freo_redirect('file/media/' . $_SESSION['plugin']['twitter_followers']['media_path'] . ($error ? '?error=1' : ''));
			}
		}
	} else {
		try {
			$consumer->getRequestToken('http://api.twitter.com/oauth/request_token', $freo->core['http_file'] . '/twitter_followers');

			$_SESSION['plugin']['twitter_followers']['request_token']        = $consumer->getToken();
			$_SESSION['plugin']['twitter_followers']['request_token_secret'] = $consumer->getTokenSecret();
		} catch (Exception $e) {
			freo_error($e->getMessage());
		}

		$_SESSION['plugin']['twitter_followers']['entry_id']   = $_GET['entry_id'];
		$_SESSION['plugin']['twitter_followers']['page_id']    = $_GET['page_id'];
		$_SESSION['plugin']['twitter_followers']['media_path'] = $_GET['media_path'];

		freo_redirect($consumer->getAuthorizeUrl('http://api.twitter.com/oauth/authenticate'));
	}

	return;
}

?>
